import pytest
import json
import os

from Common.handle_requests import send_request
from Common.handle_excel import HandleExcel
from Common.my_logger import logger
from Common.handle_path import datas_dir
from Common.handle_db import HandleDB
from Common.handle_data import replace_case_by_regular
from Common.handle_phone import get_new_phone
# from interface.Common.handle_config import conf
from Common.handle_envdata import EnvData


class TestRegister:
    exc = HandleExcel(os.path.join(datas_dir, 'api_cases.xlsx'), "注册")
    cases = exc.read_all_datas()
    exc.close_file()

    @pytest.mark.parametrize("case", cases)
    def test_register(self, case):
        logger.info("**********  执行用例{}：{}  **********".format(case["id"], case["title"]))
        # 获取到测试用例中需要替换的占位符
        if case["request_data"].find("#mobile_phone") != -1:
            if case["id"] != 9:
                mobile_phone = get_new_phone()
                # 把注册成功的手机号和密码写入到配置文件中，给登录用 方法二
                setattr(EnvData, "mobile_phone", mobile_phone)
                setattr(EnvData, "pwd", json.loads(case["request_data"])["pwd"])
            # 替换Excel中几条成功注册用例的手机号码，实现动态（方法二）
            case = replace_case_by_regular(case)
        # 使用excel中第一条用例
        # if case["id"] == 1:
        # # 把注册成功的手机号写入到配置文件中，给登录用 方法一
        # conf.write_data("userInfo", "mobile_phone", new_phone)
        # # 获取到注册成功的密码，把密码写入配置文件中
        # pwd = json.loads(case["request_data"])["pwd"]
        # conf.write_data("userInfo", "pwd", pwd)

        # 替换Excel中几条成功注册用例的手机号码，实现动态（方法一）
        # if case["request_data"].find("#new_phone") != -1:
        #     new_phone = get_new_phone()
        #     case = replace_mark_with_data(case, "#new_phone#", str(new_phone))

        # 将数据格式由字符转化成字典
        expected = eval(case["expected"])
        # 步骤 测试数据
        res = send_request(case["method"], case["url"], case["request_data"])
        logger.info("期望结果为：{}".format(case["expected"]))
        # 断言
        try:
            # self.assertEqual(expected["code"], res.json()["code"])
            assert expected["code"] == res.json()["code"]
            # self.assertEqual(expected["msg"], res.json()["msg"])
            assert expected["msg"] == res.json()["msg"]
            # 如果check_sql有值，需要对数据库进行校验
            if case["check_sql"]:
                db = HandleDB()
                result = db.select_one_data(case["check_sql"])
                db.close()
                # self.assertIsNotNone(result)
                assert result
        except AssertionError:
            logger.exception("断言失败，用例不通过！")
            raise
        else:
            logger.exception("断言成功，用例通过！")
